# 10.12.23

# Class import
from Src.Util.Helper.headers import get_headers
from Src.Util.Helper.console import console

# General import
import requests, sys, json
from bs4 import BeautifulSoup

def domain_version():

    console.print("[green]Get rules ...")
    req_repo = requests.get("https://raw.githubusercontent.com/Ghost6446/Streaming_comunity_data/main/data.json")

    if req_repo.ok:
        site_req = requests.get(f"https://streamingcommunity.{req_repo.json()['domain']}/", headers={'user-agent': get_headers()}).text
        soup = BeautifulSoup(site_req, "lxml")
        version = json.loads(soup.find("div", {"id": "app"}).get("data-page"))['version']
        console.print(f"[blue]Rules [white]=> [red].{req_repo.json()['domain']}")

        return req_repo.json()['domain'], version
    
    else:
        console.log(f"[red]Error: {req_repo.status_code}")
        sys.exit(0)

def search(title_search, domain):

    req = requests.get(f"https://streamingcommunity.{domain}/api/search?q={title_search}", headers={'user-agent': get_headers()})

    if req.ok:
        return [{'name': title['name'], 'type': title['type'], 'id': title['id'], 'slug': title['slug']} for title in req.json()['data']]
    else:
        console.log(f"[red]Error: {req.status_code}")
        sys.exit(0)